## mingw-w64-ghdl-5.1.1-1.src.tar.zst

=== doc/requirements.txt ===
-r ../pyGHDL/requirements.txt

sphinx ~= 8.2
python-dateutil ~= 2.9

# Sphinx Extenstions
autoapi ~= 2.0
myst-parser ~= 4.0
sphinx_autodoc_typehints ~= 3.2

# Theme
furo

# BuildTheDocs Extensions (mostly patched Sphinx extensions)
#btd.sphinx.autoprogram>=0.1.7.post1

=== pyGHDL/cli/requirements.txt ===
-r ../dom/requirements.txt

pyTooling[terminal] ~= 8.5

=== testsuite/gna/issue2780/Makefile ===
VHDL_SOURCES = $(PWD)/ent.vhdl
MODULE = ent_test
TOPLEVEL = ent
SIM = ghdl
SIM_ARGS=--wave=wave.ghw --vpi-trace

include $(shell cocotb-config --makefiles)/Makefile.sim

=== PKGBUILD ===
_realname=ghdl
pkgbase="mingw-w64-${_realname}"
pkgname=(
  "${MINGW_PACKAGE_PREFIX}-${_realname}-llvm"
  "${MINGW_PACKAGE_PREFIX}-${_realname}-mcode"
)
pkgver=5.1.1
pkgrel=1
pkgdesc='GHDL: the open-source analyzer, compiler, simulator and (experimental) synthesizer for VHDL'
arch=('any')
mingw_arch=('mingw64' 'ucrt64')
url='https://github.com/ghdl/ghdl'
license=('spdx:GPL-2.0-or-later')
groups=("${MINGW_PACKAGE_PREFIX}-eda")
depends=(
  "${MINGW_PACKAGE_PREFIX}-cc-libs"
  "${MINGW_PACKAGE_PREFIX}-gcc-ada"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-clang"
  "${MINGW_PACKAGE_PREFIX}-llvm"
  "${MINGW_PACKAGE_PREFIX}-autotools"
)
checkdepends=("${MINGW_PACKAGE_PREFIX}-python-pytest")
options=(!emptydirs)
source=("https://github.com/ghdl/ghdl/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('00cd58ec8f25e2532465aabc8705f43071f20dc1d13e03fd9dc235523186fca9')

build() {
  echo "Building ghdl-llvm..."
  mkdir -p "${srcdir}"/build-${MSYSTEM}-llvm && cd "${srcdir}"/build-${MSYSTEM}-llvm

  CC=clang \
  CXX=clang++ \
  MSYS2_ARG_CONV_EXCL="--prefix" \
  ../${_realname}-${pkgver}/configure \
    --prefix=${MINGW_PREFIX} \
    --enable-checks \
    --enable-libghdl \
    --enable-synth \
    --with-llvm-config

  make GNATMAKE="gnatmake -j$(nproc)"

  echo "Building ghdl-mcode..."
  mkdir -p "${srcdir}"/build-${MSYSTEM}-mcode && cd "${srcdir}"/build-${MSYSTEM}-mcode

  MSYS2_ARG_CONV_EXCL="--prefix" \
  ../${_realname}-${pkgver}/configure \
    --prefix=${MINGW_PREFIX} \
    --enable-checks \
    --enable-libghdl \
    --enable-synth

  make GNATMAKE="gnatmake -j$(nproc)"
}

check() {
  cd "${srcdir}/build-${MSYSTEM}-llvm"
  make install.vpi.local
  make test
}

package_ghdl-llvm() {
  pkgdesc+=" (LLVM backend) (mingw-w64)"
  depends+=("${MINGW_PACKAGE_PREFIX}-llvm-libs")
  provides=("${MINGW_PACKAGE_PREFIX}-${_realname}")
  cd "${srcdir}"/build-${MSYSTEM}-llvm
  make DESTDIR="${pkgdir}" install

  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})
  sed -s "s|${PREFIX_DEPS}|${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}/lib/libghdl.link
  sed -s "s|${PREFIX_DEPS}|${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}/lib/ghdl/grt.lst

  # License
  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/doc/licenses.rst "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}-llvm/licenses.rst
}

package_ghdl-mcode() {
  pkgdesc+=" (mcode backend) (mingw-w64)"
  depends+=("${MINGW_PACKAGE_PREFIX}-zlib")
  conflicts=("${MINGW_PACKAGE_PREFIX}-ghdl-llvm")
  cd "${srcdir}"/build-${MSYSTEM}-mcode
  make DESTDIR="${pkgdir}" install

  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})
  sed -s "s|${PREFIX_DEPS}|${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}/lib/libghdl.link

  # License
  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/doc/licenses.rst "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}-mcode/licenses.rst
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
